' Steganographie mit .BMP-Dateien: Nachricht innerhalb der
' Paletten-Reihenfolge verstecken, ferner auch 32-Bit-aligned-Lcke nutzen
' Entschlsselungsroutine
' (c) 2001 by Andras Meile, CH-8242 Hofen SH

INPUT "Name der Bilddatei mit Nachricht (ohne .BMP!)"; q$

DIM pal&(255), zt%(255), su%(105)

' Bilddatei sofort analysieren
OPEN q$ + ".bmp" FOR INPUT AS 1
CLOSE 1
OPEN q$ + ".bmp" FOR BINARY AS 1
IF LOF(1) < 54 THEN
  PRINT "Fehler: Keine .BMP-Datei (zu kurz)"
  CLOSE 1
  END
END IF
' BITMAPFILEHEADER auswerten
bfType$ = INPUT$(2, 1)
IF bfType$ <> "BM" THEN
  PRINT "Keine gltige .BMP-Datei"
  CLOSE 1
  END
END IF
SEEK 1, 11&
bfOffBits& = CVL(INPUT$(4, 1))  ' ab hier beginnen die Bilddaten
' BITMAPINFOHEADER auswerten
biSize& = CVL(INPUT$(4, 1))
biWidth& = CVL(INPUT$(4, 1))
biHeight& = CVL(INPUT$(4, 1))
biPlanes% = CVI(INPUT$(2, 1))
IF biPlanes% <> 1 THEN
  PRINT ".BMP-Datei irgend einer zuknfigen Windowsversion"
  CLOSE 1
  END
END IF
biBitCount% = CVI(INPUT$(2, 1))
IF biBitCount% <> 8 THEN
  PRINT "Keine 8-Bit-Paletten-Bilddatei mit 256 Farben!"
  CLOSE 1
  END
END IF
biCompression& = CVL(INPUT$(4, 1))
IF biCompression& <> 0& THEN  ' BI_RGB
  PRINT "Bilddatei ist komprimiert; nicht untersttzt"
  CLOSE 1
  END
END IF
' Grssencheck
' 1038=sizeof(BITMAPFILEHEADER)+256*sizeof(RGBQUAD)
IF bfOffBits& < biSize& + 1038& THEN
  PRINT "Bilddatei besitzt zuwenig Palettenfarben"
  CLOSE 1
  END
END IF
' Grsse ungenutzte Lcke
lck% = 3 - CINT(biWidth& + 3& AND 3&)
IF LOF(1) < bfOffBits& + biHeight& * (biWidth& + CLNG(lck%)) THEN
  PRINT "Bilddatei zu klein (mglicherweise korrupt)"
  CLOSE 1
  END
END IF

' Jetzt sind alle Parameter o.k. => extrahieren

' Palette lesen
SEEK 1, 15& + biSize&
FOR i% = 0 TO 255
  pal&(i%) = CVL(INPUT$(4, 1))
  zt%(i%) = i%
NEXT i%

' Palette sortieren
FOR i% = 0 TO 254
  FOR j% = i% + 1 TO 255
    IF pal&(j%) < pal&(i%) THEN
      SWAP pal&(i%), pal&(j%)
      SWAP zt%(i%), zt%(j%)
    END IF
  NEXT j%
NEXT i%

' Demodulieren: Nachricht herausextrahieren
FOR i% = 0 TO 105
  su%(i%) = 0
NEXT i%

FOR t% = 256 TO 1 STEP -1
  u% = zt%(t% - 1)
  h% = 0
  WHILE zt%(h%) <> t% - 1
    h% = h% + 1
  WEND
  SWAP zt%(h%), zt%(t% - 1)
  ' Operation su% = su% * t% + u%
  FOR i% = 0 TO 105
    m1& = CVL(MKI$(su%(i%)) + MKI$(0)) * CLNG(t%) + CLNG(u%)
    su%(i%) = CVI(LEFT$(MKL$(m1&), 2))
    u% = CVI(RIGHT$(MKL$(m1&), 2))
  NEXT i%
NEXT t%

inh$ = ""
FOR i% = 0 TO 104
  inh$ = inh$ + MKI$(su%(i%))
NEXT i%

' Lckeninhalt herausholen
FOR y& = 1 TO biHeight&
  SEEK 1, bfOffBits& + (y& - 1&) * (biWidth& + CLNG(lck%)) + 1& + biWidth&
  inh$ = inh$ + INPUT$(lck%, 1)
NEXT y&
CLOSE 1

' Nachricht: Plausibilitt prfen
l% = CVI(LEFT$(inh$, 2))
IF l% < 0 OR l% > LEN(inh$) - 2 THEN
  PRINT "Keine gltige Nachricht enthalten"
  END
END IF

PRINT "Nachricht wurde erfolgreich extrahiert"
INPUT "Dateiname fr Nachricht"; o$

OPEN o$ FOR OUTPUT AS 1
PRINT #1, MID$(inh$, 3, l%);
CLOSE 1

