' Steganographie mit .BMP-Dateien: Nachricht innerhalb der
' Paletten-Reihenfolge verstecken, ferner auch 32-Bit-aligned-Lcke nutzen
' (c) 2001 by Andras Meile, CH-8242 Hofen SH

PRINT "Die Trgerdatei muss eine unkomprimierte 8-Bit-Windows Bitmap-Datei sein"
INPUT "Name der Trgerdatei (ohne .BMP!)"; q$

DIM pal&(255), zt%(255), ft%(255), su%(105), invzt%(255), tt%(255)

RANDOMIZE TIMER

' Trgerdatei sofort analysieren
OPEN q$ + ".bmp" FOR INPUT AS 1
CLOSE 1
OPEN q$ + ".bmp" FOR BINARY AS 1
IF LOF(1) < 54 THEN
  PRINT "Fehler: Keine .BMP-Datei (zu kurz)"
  CLOSE 1
  END
END IF
bfType$ = INPUT$(2, 1)
IF bfType$ <> "BM" THEN
  PRINT "Keine gltige .BMP-Datei"
  CLOSE 1
  END
END IF
bfSize& = CVL(INPUT$(4, 1))
zuKopieren1$ = INPUT$(4, 1)     ' 1:1 bernehmen
bfOffBits& = CVL(INPUT$(4, 1))  ' ab hier beginnen die Bilddaten
biSize& = CVL(INPUT$(4, 1))

biWidth& = CVL(INPUT$(4, 1))
biHeight& = CVL(INPUT$(4, 1))
biPlanes% = CVI(INPUT$(2, 1))
IF biPlanes% <> 1 THEN
  PRINT ".BMP-Datei irgend einer zuknfigen Windowsversion"
  CLOSE 1
  END
END IF
biBitCount% = CVI(INPUT$(2, 1))
IF biBitCount% <> 8 THEN
  PRINT "Keine 8-Bit-Paletten-Bilddatei; bitte auf 256 Farben konvertieren!"
  CLOSE 1
  END
END IF
biCompression& = CVL(INPUT$(4, 1))
IF biCompression& <> 0& THEN  ' BI_RGB
  PRINT "Bilddatei ist komprimiert; bitte unkomprimiert abspeichern"
  CLOSE 1
  END
END IF
' Grssencheck
' 1038=sizeof(BITMAPFILEHEADER)+256*sizeof(RGBQUAD)
IF bfOffBits& < biSize& + 1038& THEN
  PRINT "Bilddatei besitzt zuwenig Palettenfarben"
  CLOSE 1
  END
END IF
' Grsse ungenutzte Lcke
lck% = 3 - CINT(biWidth& + 3& AND 3&)
IF LOF(1) < bfOffBits& + biHeight& * (biWidth& + CLNG(lck%)) THEN
  PRINT "Bilddatei zu klein (mglicherweise korrupt)"
  CLOSE 1
  END
END IF

' Jetzt sind alle Parameter o.k.
biSizeImage& = CVL(INPUT$(4, 1))
zuKopieren2$ = INPUT$(CINT(biSize& - 24&), 1) ' Daten ab biSizeImage

' Berechnung max. Platz innerhalb der Palette
' c# = 0#
' FOR i% = 1 TO 256
'   c# = c# + LOG(CDBL(i%))
' NEXT i%
' PRINT c# / LOG(256#)
' => 210.499536
' Header: 2 Bytes (Lnge) => 208 Bytes

nachrGr% = 208 + CINT(biHeight&) * lck%
PRINT "Trgerbild ist geeignet. Es bietet Platz fr die Verbergung"
PRINT "einer max."; nachrGr%; "Bytes grosse Nachrichtendatei"

INPUT "Datei mit geheimem Inhalt"; m$
OPEN m$ FOR INPUT AS 2
CLOSE 2
OPEN m$ FOR BINARY AS 2
IF LOF(2) > CLNG(nachrGr%) THEN
  PRINT "Nachrichtendatei zu gross!"
  CLOSE 2
  CLOSE 1
  END
END IF

' Datei in Ordnung => lesen
l% = CINT(LOF(2))
inh$ = MKI$(l%) + INPUT$(l%, 2)
' Verbleibender Platz mit Zufallsmll fllen
FOR i% = l% + 1 TO nachrGr%
  inh$ = inh$ + CHR$(CINT(INT(256! * RND)))
NEXT i%
CLOSE 2

' Palette lesen
FOR i% = 0 TO 255
  pal&(i%) = CVL(INPUT$(4, 1))
  zt%(i%) = i%
  ft%(i%) = i%
NEXT i%

' Palette sortieren
FOR i% = 0 TO 254
  FOR j% = i% + 1 TO 255
    IF pal&(j%) < pal&(i%) THEN
      SWAP pal&(i%), pal&(j%)
      SWAP zt%(i%), zt%(j%)
    END IF
  NEXT j%
NEXT i%

' Identische Farben ersetzen
fl% = 0
h& = -1&
FOR i% = 0 TO 255
  IF pal&(i%) = h& THEN
    ft%(zt%(i%)) = k%
    fl% = -1
    DO
      p& = CLNG(INT(4096! * 4096! * RND))
      f% = 0
      FOR j% = 0 TO 255
        IF p& = pal&(j%) THEN
          f% = -1
          EXIT FOR
        END IF
      NEXT j%
    LOOP WHILE f%
    pal&(i%) = p&
  ELSE
    h& = pal&(i%)
    k% = zt%(i%)
  END IF
NEXT i%

' Falls ntig nochmals sortieren
IF fl% THEN
  FOR i% = 0 TO 254
    FOR j% = i% + 1 TO 255
      IF pal&(j%) < pal&(i%) THEN
        SWAP pal&(i%), pal&(j%)
        SWAP zt%(i%), zt%(j%)
      END IF
    NEXT j%
  NEXT i%
END IF

' Daten hineinmodulieren
FOR i% = 0 TO 104
  su%(i%) = CVI(MID$(inh$, 1 + 2 * i%, 2))
NEXT i%
su%(105) = CINT(INT(15! * RND))

FOR t% = 1 TO 256
  ' Operation r% = su% MOD t%, su% = su% \ t%
  r% = 0
  FOR i% = 105 TO 0 STEP -1
    d1& = CVL(MKI$(su%(i%)) + MKI$(r%))
    su%(i%) = CVI(LEFT$(MKL$(d1& \ CLNG(t%)), 2))
    r% = CINT(d1& MOD CLNG(t%))
  NEXT i%
  SWAP pal&(r%), pal&(t% - 1)
  SWAP zt%(r%), zt%(t% - 1)
NEXT t%

INPUT "Bilddatei mit versteckter Nachricht (ohne .BMP!)"; o$
OPEN o$ + ".bmp" FOR OUTPUT AS 2
' BITMAPFILEHEADER schreiben
PRINT #2, "BM"; MKL$(1038& + biSize& + biHeight& * (biWidth& + CLNG(lck%)));
PRINT #2, zuKopieren1$; MKL$(1038& + biSize&);
' 1038=sizeof(BITMAPFILEHEADER)+256*sizeof(RGBQUAD)
' ^_ Anmerkung: bfOffBits neu berechnet
' BITMAPINFOHEADER schreiben
PRINT #2, MKL$(biSize&); MKL$(biWidth&); MKL$(biHeight&); MKI$(biPlanes%);
PRINT #2, MKI$(biBitCount%); MKL$(biCompression&);
PRINT #2, MKL$(biHeight& * (biWidth& + CLNG(lck%))); zuKopieren2$;
' Farbpalette speichern und Palettennummertransformationstabelle bilden
FOR i% = 0 TO 255
  PRINT #2, MKL$(pal&(i%));
  invzt%(zt%(i%)) = i%
NEXT i%
FOR i% = 0 TO 255
  tt%(i%) = invzt%(ft%(i%))
NEXT i%

' Bild bertragen

ip% = 211
FOR y& = 1 TO biHeight&
  SEEK 1, bfOffBits& + (y& - 1&) * (biWidth& + CLNG(lck%)) + 1&
  FOR x& = 1 TO biWidth&
    z% = ASC(INPUT$(1, 1))
    PRINT #2, CHR$(tt%(z%));
  NEXT x&
  PRINT #2, MID$(inh$, ip%, lck%);
  ip% = ip% + lck%
NEXT y&

CLOSE 2
CLOSE 1

